package util;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class MyListImplTest {
  
  private MyListImpl<Integer> sut;
  private MyListImpl<Integer> sut12;
  
  @BeforeEach
  public void setUp() {
    this.sut = new MyListImpl<>();
    this.sut12 = new MyListImpl<>();
    this.sut12.add(1);
    this.sut12.add(2);
  }

  @Test
  public void testSize0() {
    Assertions.assertEquals(0, sut.size());
  }
    
  @Test
  public void testGet1() {
    Assertions.assertEquals(1, sut12.get(0));
  }
  
  @Test
  public void testGet2() {
    Assertions.assertEquals(2, sut12.get(1));
  }
  
  @Test
  public void testGet3() {
    try {
      sut12.get(-1);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testGet4() {
    try {
      sut12.get(2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testSize1() {
    Assertions.assertEquals(2, sut12.size());
  }
  
  @Test
  public void testSize2() {
    sut12.add(0,4);
    sut12.add(1,5);
    sut12.add(3,6);
    sut12.add(5,7);
    Assertions.assertEquals(6, sut12.size());
  }
  
  @Test
  public void testIsEmpty1() {
    Assertions.assertTrue(sut.isEmpty());
  }
  
  @Test
  public void testIsEmpty2() {
    Assertions.assertFalse(sut12.isEmpty());
  }
  
  @Test
  public void testAdd1() {
    sut12.add(0, 3);
    Assertions.assertEquals(3, sut12.get(0));
    Assertions.assertEquals(3, sut12.size());
  }
  
  @Test
  public void testAdd2() {
    sut12.add(1, 3);
    Assertions.assertEquals(3, sut12.get(1));
    Assertions.assertEquals(3, sut12.size());
  }
  
  @Test
  public void testAdd3() {
    sut12.add(2, 3);
    Assertions.assertEquals(3, sut12.get(2));
    Assertions.assertEquals(3, sut12.size());
  }
  
  @Test
  public void testAdd4() {
    try {
      sut12.add(-1, 3);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testAdd5() {
    try {
      sut12.add(3, 2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testAdd6() {
    try {
      sut.add(1, 2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testSet1() {
    sut12.set(0, 42);
    sut12.set(1, 43);
    Assertions.assertEquals(42, sut12.get(0));
    Assertions.assertEquals(43, sut12.get(1));
    Assertions.assertEquals(2, sut12.size());
  }
  
  @Test
  public void testSet2() {
    try {
      sut12.set(2, 2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testSet3() {
    try {
      sut12.set(-1, 2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testSet4() {
    try {
      sut.set(1, 2);
      Assertions.fail();
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testRemove1() {
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertEquals(2, sut12.get(0));
    Assertions.assertEquals(1, sut12.size());
  }
  
  @Test
  public void testRemove2() {
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertEquals(0, sut12.size());
  }
  
  @Test
  public void testRemove3() {
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertFalse(sut12.remove(0));
    Assertions.assertEquals(0, sut12.size());
  }
  
  @Test
  public void testRemove4() {
    try {
      sut12.remove(-1);
      Assertions.fail(sut12 + ", kein remove an Stelle -1");
    } catch (IllegalArgumentException e) {
    }
  }
  
  @Test
  public void testRemove5() {
    sut12.add(3);
    Assertions.assertTrue(sut12.remove(2));
    Assertions.assertTrue(sut12.remove(1));
    Assertions.assertTrue(sut12.remove(0));
    Assertions.assertEquals(0, sut12.size());
  }
  
  @Test
  public void testContains() {
    Assertions.assertTrue(sut12.contains(1));
    Assertions.assertTrue(sut12.contains(2));
    Assertions.assertFalse(sut12.contains(0));
    Assertions.assertEquals(2, sut12.size());
  }
  
  @Test
  public void testIndexOf() {
    Assertions.assertEquals(0, sut12.indexOf(1));
    Assertions.assertEquals(1, sut12.indexOf(2));
    Assertions.assertEquals(-1, sut12.indexOf(0));
    Assertions.assertEquals(2, sut12.size());
  }
  
  @Test
  public void testIterator1() {
    String erg = "";
    for (Integer val: sut12) {
      erg += val;
    }
    Assertions.assertEquals("12", erg);
  }
  
  @Test
  public void testIterator2() {
    String erg = "";
    for (Integer val: sut) {
      erg += val;
    }
    Assertions.assertEquals("", erg);
  }
}
